preprocessing for using indent as { }

28 Aug 2011

// start at N
// assume one tok and tokcol in stack
// state  do    condition      action       next
// N      lex   eof match      out eof      N
// N      lex   eof not match  out } pop    N
// N      lex   oldline        out tok      N
// N      lex   nl =           out tok      N
// N      lex   nl >           out { push   O
// N      lex   nl <           out } pop    O
// O                           out tok      N

void mylex3(void){
    int oldline;
    static int oldtok;

    switch(lexstate){
    case LEX_NEW:
        oldline = line;
        mylex2();
        // order of decision is important
        if( tok == tkEOF ){
            if( colstkp > 1 ){			// check match
                tok = tkRBRACE;			// out }
                popcol();
            }
        }else if( line != oldline ){		// new line
            if( tokcol > topcol() ){		// out {
                oldtok = tok;
                tok = tkLBRACE;
                pushcol();
                lexstate = LEX_OLD;
            }else if ( tokcol < topcol() ){ // out }
                oldtok = tok;
                tok = tkRBRACE;
                popcol();
                lexstate = LEX_OLD;
            }			// tokcol == topcol, out tok
        }		// old line, out tok
        break;
    case LEX_OLD:
        tok = oldtok;
        lexstate = LEX_NEW;
        break;
    }
}
